Folder Browser is not accessible by keyboard nor readable by Narrator, etc.
Closed, ResolvedPublic

Description

Figure out what to do next.

Karen created her own custom control for folder browsing in Directory Printer. Unfortunately, the control isn't designated as a tab stop, so tabbing around the form never lands there. This does break good Windows form design, which says all controls should be reachable without using a mouse. This also means that screen readers for the visually impaired don't read the browser, making Directory Printer useless for anybody who cannot see.

I noticed right away that the screen claims to afford the keyboard accelerator Alt-F to enter the browser, but Alt-F toggles one of the checkbox controls.

Orlando in this ticket wrote:

I am currently using Jaws for Windows version 2019, which is not free. But results are no better with Narrator or NVDA, which are free.

The problem is that Directory Printer has a child window where files and/or folders are selected. There is no way to enter this window with the keyboard or a simulated mouse because the window has no tab stop that any screen reader recognizes. Simply load Narrator and try to use any of its navigational commands to enter the file/folder selector child window. You will find it is impossible.

Joe created this task.Nov 12 2018, 8:46 AM
Joe created this object in space S5 Public.
Joe created this object with visibility "Public (No Login Required)".
Joe added a comment.Nov 14 2018, 10:22 AM

Removed the &Folder and &Network misinformation. Still no good reason the tab stops don't work, though. They should and they do if I add the control to a freshly created form.

Joe added a comment.Nov 14 2018, 10:27 AM

Apparently Karen was working on this problem. She tried to specifically set the focus to the control when the tab was selected, but that doesn't cause the focus to end up on a sub-control within her UserControl.

Case TAB_PRINT
            picPrint2.Visible = True
            picSave2.Visible = False
            btnPrint.Default = True
            If brwPrint.Visible And brwPrint.Enabled Then brwPrint.SetFocus ' Was commented out -- but doesn't work
            EnablePrint

Case TAB_SAVE
            picSave2.Visible = True
            picPrint2.Visible = False
            btnSave.Default = True
            If brwSave.Visible And brwSave.Enabled Then brwSave.SetFocus '  Was commented out -- but doesn't work
            EnablePrint
            EnableSave
Joe added a comment.Nov 14 2018, 10:37 AM

The control itself isn't enabled in the form definition. Enabling them seems to fix the problem.

Joe closed this task as Resolved.Nov 14 2018, 10:40 AM
Joe added a comment.Nov 15 2018, 10:24 PM

Orlando tested Directory Printer v5.4.2:

It sure does, as does the tab stop. I am so delighted, Joe! Thank you ever so much.

Coolness!